var getKey = function(column) {
	var key = column;
      switch(column) {
        case 'suser.first_name':
          return 'FIRST_NAME';
        case 'suser.middle_name':
          return 'MIDDLE_NAME';
        case 'suser.last_name':
          return 'LAST_NAME';
        case 'suser.email':
          return 'EMAIL';
        case 'suser.display_name':
          return 'DISPLAY_NAME'
        case 'suser.dn':
          return 'DN';
        case 'suser.location':
          return 'LOCATION';
        case 'suser.department':
          return 'DEPARTMENT';
        case 'suser.job_title':
          return 'JOB_TITLE';
        case 'supervisor.display_name':
          return 'SUPERVISOR';
        case 'suser.all_permissions':
          return 'ALL_PERMISSIONS';
        case 'suser.certification_count':
          return 'CERTIFICATION_COUNT'
        case 'suser.is_certified':
          return 'IS_CERTIFIED'
        case 'suser.certification_pending':
          return 'CERTIFICATION_PENDING'
        case 'spermissions.application_name':
          return 'APPLICATION_NAME'
        case 'spermissions.application_risk':
          return 'APPLICATION_RISK'
        case 'spermissions.permission_name':
          return 'PERMISSION_NAME'
        case 'spermissions.permission_risk':
          return 'PERMISSION_RISK'
        case 'suser.aggregate_permission_risk':
          return 'AGGREGATE_PERMISSION_RISK'
        case 'spermissions.last_certification':
          return 'LAST_CERT'
        case 'suser.risk':
          return 'RISK'
        case 'NULL':
          return 'NONE'
        case 'sgroup.group_name':
          return 'GROUP_NAME'
      }
    return column;
};

var concatColumns = function(columns, localizer) {
  var resultList = [];

  var strArray = columns.split(" || ' ' || ");
  strArray.forEach(function(element) {
    resultList.push(getKey(element));
  });

  return resultList.map(function(str) {
    return localizer.getString(str);
  }).join(' + ');
};

var localizeColumn = function(column, localizer) {
  if(column !== null && localizer !== null) {
      if(column.indexOf('||') !== -1) {
        return concatColumns(column, localizer);
      }
      key = getKey(column);
      return localizer.getString(key);
    }
    return column;
  };

var localizeArrayOfColumns = function(columnsArray, localizer) {
	var resultList = [];
	if(columnsArray !== null && localizer !== null) {
		columnsArray.forEach(function(element) {
      if(element.indexOf('||') !== -1) {
        resultList.push(concatColumns(element, localizer));
      }
      else {
        resultList.push(getKey(element));
      }
		});
	}

	return resultList.map(function(str) {
		return localizer.getString(str);
	}).join(', ');
};

var prepareField = function(field, databaseplatform) {
  if(field.indexOf("||") !== -1) {
    var resultList = field.split(" || ' ' || ");
    if(databaseplatform === "postgres") {
      return resultList.map(function(str) {
        return "coalesce(" + str + "::text, '')";
      }).join(" || ' ' || ");
    }
    else if(databaseplatform === "oracle") {
      return resultList.map(function(str) {
        return "COALESCE(TO_CHAR(" + str + "), TO_CHAR(''))";
      }).join(" || ' ' || ");
    }
    else if(databaseplatform === "mssql") {
      return resultList.map(function(str) {
        return "COALESCE(CAST(" + str + " AS NVARCHAR(MAX)), '')";
      }).join(" + ' ' + ");
    }
  }
  return field;
};